CREATE OR REPLACE FUNCTION GERA_CODIGOBARRA_FECHAOP(
   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
   P_CDPRODUTO    IN ORDPRODUCAO.CDPRODUTO%TYPE,
   P_NRLOTEESTQ   IN ORDPRODUCAO.NRLOTEESTQ%TYPE,
   P_NRSUBLOTE    IN ORDPRODUCAO.NRSUBLOTE%TYPE,
   P_QTDE         IN ORDPRODUCAO.QTAPRODPREOP%TYPE) RETURN VARCHAR IS

   V_IDTIPOPRODPAR VARCHAR2(01);
   V_IDUTQTCODBARRA VARCHAR2(01);
   V_QTNUMEROINT FLOAT;
   V_QTNUMERODEC FLOAT;
   V_IDTPSEPARADOR VARCHAR2(01);
   V_IDUTALLCCODBARRA VARCHAR(01);
   V_QTTAMALMOX FLOAT;
   V_QTTAMLOCAL FLOAT;
   V_IDUTLTSUBCODBAR VARCHAR2(01);
   V_QTTAMLOTE FLOAT;
   V_QTTAMSUBLOTE FLOAT;
   V_QTTAMCDBARRA FLOAT;
   V_IDFILIPADIMPEST VARCHAR2(01);
   V_CDPRODUTO       VARCHAR2(30);
   V_IDUTILALMOX     VARCHAR2(01);
   V_IDUTILLCESTQ    VARCHAR2(01);
   V_IDUTILLOTE      VARCHAR2(01);
   V_CDALMOX         VARCHAR2(06);
   V_CDALMOXARIFADO  VARCHAR2(06);
   V_LOCAL           VARCHAR2(06);
   V_CDLOCALESTOQ      VARCHAR2(06);
   V_LOTE            VARCHAR2(20);
   V_SUBLOTE         VARCHAR2(04);
   STQTDE            VARCHAR2(100);
   V_RESULT          VARCHAR2(500);
BEGIN
   BEGIN
      SELECT NVL(MAX(IDTIPOPRODPAR),'C') AS IDTIPOPRODPAR,
             NVL(MAX(IDUTQTCODBARRA), 'S') AS IDUTQTCODBARRA, NVL(MAX(QTNUMEROINT), 10) AS QTNUMEROINT, NVL(MAX(QTNUMERODEC), 5) QTNUMERODEC, NVL(MAX(IDTPSEPARADOR), '2') IDTPSEPARADOR,
             NVL(MAX(IDUTALLCCODBARRA), 'S') AS IDUTALLCCODBARRA, NVL(MAX(QTTAMALMOX), 6) AS QTTAMALMOX, NVL(MAX(QTTAMLOCAL), 6) AS QTTAMLOCAL,
             NVL(MAX(IDUTLTSUBCODBAR), 'S') AS IDUTLTSUBCODBAR, NVL(MAX(QTTAMLOTE), 20) AS QTTAMLOTE, NVL(MAX(QTTAMSUBLOTE), 4) AS QTTAMSUBLOTE,
             NVL(MAX(QTTAMCDBARRA),30) AS QTTAMCDBARRA, NVL(MAX(IDFILIPADIMPEST),'N') AS IDFILIPADIMPEST
        INTO V_IDTIPOPRODPAR,
             V_IDUTQTCODBARRA, V_QTNUMEROINT, V_QTNUMERODEC, V_IDTPSEPARADOR,
             V_IDUTALLCCODBARRA, V_QTTAMALMOX, V_QTTAMLOCAL,
             V_IDUTLTSUBCODBAR, V_QTTAMLOTE, V_QTTAMSUBLOTE,
             V_QTTAMCDBARRA, V_IDFILIPADIMPEST
        FROM PARAMIMPEST P
       WHERE (CDFILPARIMPEST  = P_CDFILIAL);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDTIPOPRODPAR := 'C';
          V_IDUTQTCODBARRA :='S'; V_QTNUMEROINT := 10; V_QTNUMERODEC:=5; V_IDTPSEPARADOR := '2';
          V_IDUTALLCCODBARRA := 'S'; V_QTTAMALMOX:=6; V_QTTAMLOCAL :=6;
          V_IDUTLTSUBCODBAR := 'S'; V_QTTAMLOTE:=20; V_QTTAMSUBLOTE:=4;
          V_QTTAMCDBARRA:=30; V_IDFILIPADIMPEST:='N';
   END;
   IF V_IDTIPOPRODPAR = 'C' THEN --Cdigo do produto
      V_CDPRODUTO := P_CDPRODUTO;
   ELSIF V_IDTIPOPRODPAR = 'B' THEN --Cdigo de barras
      SELECT MAX(CDBARPRODUTO)
        INTO V_CDPRODUTO
        FROM PRODUTO
       WHERE CDPRODUTO = P_CDPRODUTO;

       V_CDPRODUTO := SUBSTR(V_CDPRODUTO, 1, V_QTTAMCDBARRA);
   ELSIF V_IDTIPOPRODPAR = 'E' THEN
      SELECT MAX(CDPRODESTO)
        INTO V_CDPRODUTO
        FROM PRODUTO
       WHERE CDPRODUTO = P_CDPRODUTO;
   ELSE
      SELECT MAX(CDARVPROD)
        INTO V_CDPRODUTO
        FROM PRODUTO
       WHERE CDPRODUTO = P_CDPRODUTO;
   END IF;

   SELECT MAX(IDUTILALMOX), MAX(IDUTILLCESTQ), MAX(IDUTILLOTE)
     INTO V_IDUTILALMOX, V_IDUTILLCESTQ, V_IDUTILLOTE
     FROM PARAMFILIAL
    WHERE CDFILIAL = P_CDFILIAL;

   IF V_IDUTALLCCODBARRA = 'S' THEN
      IF V_IDUTILALMOX = 'S' THEN
         SELECT MAX(CDALMOXPRACA)
           INTO V_CDALMOXARIFADO
           FROM PRODFILI
          WHERE CDFILIAL = P_CDFILIAL
            AND CDPRODUTO = P_CDPRODUTO;

         V_CDALMOX := SUBSTR(LPAD(V_CDALMOXARIFADO, V_QTTAMALMOX, '0'),1,V_QTTAMALMOX);
      ELSE
         V_CDALMOX := '';
      END IF;

      IF V_IDUTILLCESTQ = 'S' THEN
         SELECT MAX(CDLOCALPRACA)
           INTO V_CDLOCALESTOQ
           FROM PRODFILI
          WHERE CDFILIAL = P_CDFILIAL
            AND CDPRODUTO = P_CDPRODUTO;

         V_LOCAL := SUBSTR(LPAD(V_CDLOCALESTOQ, V_QTTAMLOCAL, '0'),1,V_QTTAMLOCAL);
      ELSE
         V_LOCAL := '';
      END IF;
   ELSE
      V_CDALMOX := '';
      V_LOCAL := '';
   END IF;

   IF V_IDUTLTSUBCODBAR = 'S' THEN
      IF V_IDUTILLOTE = 'S' THEN
         V_LOTE := SUBSTR(LPAD(P_NRLOTEESTQ, V_QTTAMLOTE, '0'),1,V_QTTAMLOTE);
         V_SUBLOTE := SUBSTR(LPAD(P_NRSUBLOTE, V_QTTAMSUBLOTE, '0'),1,V_QTTAMSUBLOTE);
      ELSE
         V_LOTE := '';
         V_SUBLOTE := '';
      END IF;
   ELSE
      V_LOTE := '';
      V_SUBLOTE := '';
   END IF;

   IF V_IDUTQTCODBARRA = 'S' THEN
      STQTDE := SUBSTR(LPAD(TO_CHAR(ROUND(P_QTDE, V_QTNUMERODEC) * POWER(10, V_QTNUMEROINT)), (V_QTNUMERODEC+V_QTNUMEROINT), '0'), 1,(V_QTNUMERODEC+V_QTNUMEROINT));
   ELSE
      STQTDE := '';
   END IF;
   V_RESULT := (V_CDPRODUTO||V_CDALMOX||V_LOCAL||V_LOTE||V_SUBLOTE||STQTDE);
   RETURN(V_RESULT);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('GERA_CODIGOBARRA_FECHAOP','6.05.000'); END;
/
